<?php
namespace Teknisa\PLA\Modules\Mymeals\Controllers;

use Zeedhi\Framework\DTO;

class Pla02030AprovacaoComensaisController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $Pla02030AprovacaoComensaisService;
    
    public function __construct($crudService,$parameterBag,$Pla02030AprovacaoComensaisService) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->Pla02030AprovacaoComensaisService = $Pla02030AprovacaoComensaisService;
    }
    
    public function insereConfirmarefe(DTO\Request\DataSet $request, DTO\Response $response){
        try{
            $rows = $request->getDataSet()->getRows();
            $this->Pla02030AprovacaoComensaisService->iniciaTransacao();

            foreach ($rows as $row) {
                $this->Pla02030AprovacaoComensaisService->insereConfirmarefe($row);
                $this->Pla02030AprovacaoComensaisService->flush();
            }
            
            $this->Pla02030AprovacaoComensaisService->commit();
        }catch(\Exception $e){
            $this->Pla02030AprovacaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function aprovaCardapio(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        
        $nrorg = $row['NRORG'];
        $cdoperador = $row['CDOPERADOR'];
        $itensSelecionados = $row['ITENSSELECIONADOS'];
        foreach($itensSelecionados as $callback){
            $cdfilial = $callback['CDFILIAL'];
            $nrconfirmarefe = $callback['NRCONFIRMAREFE'];
            $cdservfili = $callback['CDSERVFILI'];
            $nrcardapio = $callback['NRCARDAPIO'];
            $dtcardapio = $callback['DTCARDAPIO'];
            $idqtdeaprovada = 'PENDENTE';
            
            $params = array(
                "NRORG" => $nrorg,
                "CDFILIAL" => $cdfilial,
                "CDSERVFILI" => $cdservfili,
                "NRCARDAPIO" => $nrcardapio,
                "DTCARDAPIO" => $dtcardapio,
                "IDQTDEAPROVADA" => $idqtdeaprovada
            );
            
            $altcardapio = $this->Pla02030AprovacaoComensaisService->getAlteracoesCardapio($params);
            $altturnos = $this->Pla02030AprovacaoComensaisService->getAlteracoesTurno($params);
            $carda = $this->Pla02030AprovacaoComensaisService->getCardadiaAprov($params);
            $altpontoentrega = $this->Pla02030AprovacaoComensaisService->getAlteracoesPontoEntrega($params);

            $qtestiturno1 = 0;
            $qtestiturno2 = 0;
            $qtestiturno3 = 0;
            $qtestiturno4 = 0;
            $qtfunesticar = 0;
            $qtdoaesticar = 0;
            $qttotalalterada = 0;
            $qtcomealterada = 0;
            $qtcomesticar = $carda->getQtcomesticar();
            $qtcliesticar = $carda->getQtcliesticar();
            $qtfunesticar = $carda->getQtfunesticar();
            $qtdoaesticar = $carda->getQtdoaesticar();

            $cdcliente = null;
            $cddestfili = null;
            
            $turnos = array(null,null,null,null);
            
            if(count($altcardapio) > 0){
                $qtcomealterada = $altcardapio[0]["QTCOMEALTERADA"];
                $qttotalalterada = $altcardapio[0]["QTTOTALALTERADA"];
            }
            
            if(count($altturnos) > 0){
                foreach($altturnos as $callback){
                    $turnos[$callback["CDTURNO"]-1] = $callback["QTCOMEALTERADA"];
                }
            }
            
            if($carda->getNrcardapio()){
                $qtfunesticar = $carda->getQtfunesticar();
                $qtdoaesticar = $carda->getQtdoaesticar();
                $qtestiturno1 = $turnos[0];
                
                if(is_null($qtestiturno1)){
                    $qtestiturno1 = $carda->getQtestiturno1();
                    $qtestiturno2 = $carda->getQtestiturno2();
                    $qtestiturno3 = $carda->getQtestiturno3();
                    $qtestiturno4 = $carda->getQtestiturno4();
                }else{
                    $qtestiturno2 = $turnos[1];
                    $qtestiturno3 = $turnos[2];
                    $qtestiturno4 = $turnos[3];
                }
            }
            
            $dadosCardadia = array(
                "NRORG" => $nrorg,
                "CDFILIAL" => $cdfilial,
                "NRCARDAPIO" => $nrcardapio,
                "QTCOMESTICAR" => $qttotalalterada,
                "QTCLIESTICAR" => $qtcomealterada,
                "QTFUNESTICAR" => $qtfunesticar,
                "QTDOAESTICAR" => $qtdoaesticar,
                "QTFUNESTICAR" => $qtfunesticar,
                "QTDOAESTICAR" => $qtdoaesticar,
                "QTESTITURNO1" => $qtestiturno1,
                "QTESTITURNO2" => $qtestiturno2,
                "QTESTITURNO3" => $qtestiturno3,
                "QTESTITURNO4" => $qtestiturno4,
                "CDOPERADOR" => $cdoperador
            );
            
            $dadosCardacli = array(
                "NRORG" => $nrorg,
                "NRCARDAPIO" => $nrcardapio,
                "CDCLIENTE" => $cdcliente,
                "CDDESTFILI" => $cddestfili,
                "QTCOMESTICLI" => $qtcomealterada,
                "CDOPERADOR" => $cdoperador
            );
            
            $dadosAprovaCardapio = array(
                "NRORG" => $nrorg,
                "NRCONFIRMAREFE" => $nrconfirmarefe,
                "CDFILIAL" => $cdfilial,
                "CDSERVFILI" => $cdservfili,
                "NRCARDAPIO" => $nrcardapio,
                "DTCARDAPIO" => $dtcardapio,
                "IDQTDEAPROVADA" => $idqtdeaprovada,
                "CDOPERADOR" => $cdoperador
            );

            $this->atuComensaisAprovaCardapio($altpontoentrega,$dadosCardadia,$dadosCardacli,$dadosAprovaCardapio,$response);
        }
    }
    
    public function reprovaCardapio(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        
        $nrorg = $row['NRORG'];
        $cdoperador = $row['CDOPERADOR'];
        $itensSelecionados = $row['ITENSSELECIONADOS'];

        foreach($itensSelecionados as $callback){
            $cdfilial = $callback['CDFILIAL'];
            $nrconfirmarefe = $callback['NRCONFIRMAREFE'];
            $cdservfili = $callback['CDSERVFILI'];
            $nrcardapio = $callback['NRCARDAPIO'];
            $dtcardapio = $callback['DTCARDAPIO'];
            $idqtdeaprovada = 'PENDENTE';

            $dadosReprovaCardapio = array(
                "NRORG" => $nrorg,
                "NRCONFIRMAREFE" => $nrconfirmarefe,
                "CDFILIAL" => $cdfilial,
                "CDSERVFILI" => $cdservfili,
                "NRCARDAPIO" => $nrcardapio,
                "DTCARDAPIO" => $dtcardapio,
                "IDQTDEAPROVADA" => $idqtdeaprovada,
                "CDOPERADOR" => $cdoperador
            );

            try{
                $this->Pla02030AprovacaoComensaisService->iniciaTransacao();

                $this->Pla02030AprovacaoComensaisService->reprovaCardapio($dadosReprovaCardapio);
                $this->Pla02030AprovacaoComensaisService->flush();
            
                $this->Pla02030AprovacaoComensaisService->commit();
            
            }catch(\Exception $e){
                $this->Pla02030AprovacaoComensaisService->rollback();
                $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
            }
        }
    }
    
    public function atuComensaisAprovaCardapio($altpontoentrega,$dadosCardadia,$dadosCardacli,$dadosAprovaCardapio, DTO\Response $response){

        try{
            $this->Pla02030AprovacaoComensaisService->iniciaTransacao();
            
            $this->Pla02030AprovacaoComensaisService->atualizaCardadia($dadosCardadia);
            $this->Pla02030AprovacaoComensaisService->flush();
            
            if(count($altpontoentrega) > 0){
                foreach($altpontoentrega as $callback) {
                    $dadosCardacli = array(
                        "NRORG" => $dadosCardacli["NRORG"],
                        "NRCARDAPIO" => $callback["NRCARDAPIO"],
                        "CDCLIENTE" => $callback["CDCLIENTE"],
                        "CDDESTFILI" => $callback["CDDESTFILI"],
                        "QTCOMEALTERADA" => $callback["QTCOMEALTERADA"],
                        "CDOPERADOR" => $dadosCardacli["CDOPERADOR"] 
                    );
                    
                    $this->Pla02030AprovacaoComensaisService->atualizaComensaisCardacli($dadosCardacli);
                    $this->Pla02030AprovacaoComensaisService->flush();
                }
            }
            
            $this->Pla02030AprovacaoComensaisService->aprovaCardapio($dadosAprovaCardapio);
            $this->Pla02030AprovacaoComensaisService->flush();
            
            $this->Pla02030AprovacaoComensaisService->commit();
            
        }catch(\Exception $e){
            $this->Pla02030AprovacaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function listaCardapio(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_cardapio";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG');

        $this->find($request, $response);
    }
    
    public function listaComensais(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_comensais";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');
        
        $this->find($request, $response);
    }
    
    public function listaTurnos(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_turno";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');

        $this->find($request, $response);
    }
    
    public function listaPontoEntrega(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_ponto_entrega";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');

        $this->find($request, $response);
    }
    
    public function listaPratos(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_prato";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO', 'IDQTDEAPROVADA');

        $this->find($request, $response);
    }
}