<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Ger08800GrupoNutrienteReport extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $birtStrategy;
    protected $reportService;

    public function __construct($reportService, $birtStrategy, $environment) {
    	$this->reportService = $reportService;
    	$this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
    }

    protected $reportMapping = array (
    "GER08800" =>
        array (
            "strategy" => "BIRT",
            "parameterMapping" =>
            array (
                "CDGRUPNUTR"   => "P_CDGRUPNUTR",
                "NRORG"     => "NRORG"
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $row['__report_name'] = 'GER08800';
            $row["NRORG"] = $this->environment->getNrOrg();
            if(isset($row['T_GRUPO']) && $row['T_GRUPO'] == 'S'){
                $row['CDGRUPNUTR'] = 'T';
            } else {
                $row['CDGRUPNUTR'] = implode('_', $row['CDGRUPNUTR']);
            }
            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
} 
